﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using System.Text;
using System.Windows.Markup;
using Infragistics.Controls.Grids.Primitives;
using System.Windows.Data;

namespace XamGridExpand
{
    public partial class ucLoadDataInTemplateColumnLayout : UserControl
    {
        List<ChildNode> lstParentChildData = new List<ChildNode>();
        ObservableCollection<ChildNode> lstCurrentData = new ObservableCollection<ChildNode>();
        ObservableCollection<ChildNode> lstChildren = new ObservableCollection<ChildNode>();
        Row ActiveRow = null;
        bool IsAlreadyExpanded = false;
        string strSelectedID = "";
        App app;
        bool isAdded = false;

        public ucLoadDataInTemplateColumnLayout()
        {
            InitializeComponent();
            app = (App)Application.Current;
            DownloadDataSource();
            xamGrid1.RowExpansionChanging += new EventHandler<CancellableRowExpansionChangedEventArgs>(xamGrid1_RowExpansionChanging);
            xamGrid1.ColumnLayoutAssigned += new EventHandler<ColumnLayoutAssignedEventArgs>(xamGrid1_ColumnLayoutAssigned);
            xamGrid1.CellClicked += new EventHandler<CellClickedEventArgs>(xamGrid1_CellClicked);
        }


        void xamGrid1_ColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {

            try
            {
                TemplateColumn objTempleteColoumn;
                int iSubFormID = 7;
                StringBuilder CellTemp;

                if (e.ColumnLayout.Columns.Count == 0)
                {
                    if (iSubFormID != 999)
                    {
                        //if (_lstTempleteColoumns.Count == 0)
                        //{
                        CellTemp = new StringBuilder();
                        CellTemp.Append("<DataTemplate ");
                        CellTemp.Append("xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' ");
                        CellTemp.Append("xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'> ");
                        CellTemp.Append("<Grid>");
                        CellTemp.Append(" <TextBlock x:Name=\"txtNormal\" Text=\"{Binding ID}\"/>");
                        CellTemp.Append(" </Grid>");
                        CellTemp.Append(" </DataTemplate>");

                        objTempleteColoumn = new TemplateColumn()
                        {
                            HeaderText = "ID",
                            Key = "ID",
                            Width = new ColumnWidth(40, false),
                            MinimumWidth = 30,
                            ////MaximumWidth = 80,
                            IsFixed = FixedState.Left,
                            IsSortable = false,
                            IsResizable = true,
                            ItemTemplate = (DataTemplate)XamlReader.Load(CellTemp.ToString())
                        };

                        e.ColumnLayout.Columns.Add(objTempleteColoumn);
                    }
                    CellTemp = new StringBuilder();
                    CellTemp.Append("<DataTemplate ");
                    CellTemp.Append("xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' ");
                    CellTemp.Append("xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'> ");
                    CellTemp.Append("<Grid>");
                    CellTemp.Append(" <TextBlock x:Name=\"txtNormal\" Text=\"{Binding Name}\" />");
                    CellTemp.Append(" <Image x:Name=\"imgNotes\" Source=\"../images/n_g.jpg\" Visibility=\"Visible\" Height=\"10\"");
                    CellTemp.Append(" HorizontalAlignment=\"Right\" Margin=\"0,1.4,0,0\" VerticalAlignment=\"Top\"></Image>");
                    CellTemp.Append(" </Grid>");
                    CellTemp.Append(" </DataTemplate>");


                    objTempleteColoumn = new TemplateColumn()
                    {
                        HeaderText = "Name",
                        Key = "Name",
                        Width = new ColumnWidth(250, false),
                        MinimumWidth = 110,
                        IsFixed = FixedState.Left,
                        IsSortable = false,
                        IsResizable = true,
                        ItemTemplate = (DataTemplate)XamlReader.Load(CellTemp.ToString())
                    };

                    e.ColumnLayout.Columns.Add(objTempleteColoumn);
                }
                e.ColumnLayout.HeaderVisibility = Visibility.Collapsed;
                int count = e.ColumnLayout.Columns.DataColumns.Count;
                if (count > 0)// && e.ColumnLayout.Columns.DataColumns.Count >= count - 1)
                {
                    e.ColumnLayout.Columns.DataColumns[count - 1].Width = ColumnWidth.Star;
                }
            }
            catch (Exception)
            {

                throw;
            }
        }

        void xamGrid1_RowExpansionChanging(object sender, CancellableRowExpansionChangedEventArgs e)
        {
            if (e.Row.HasChildren == false)
            {
                e.Cancel = true;
            }
            if (e.Row.IsExpanded == false)
                IsAlreadyExpanded = false;
            else
            {
                return;
            }

            if (ActiveRow == null && IsAlreadyExpanded == false && e.Row.GetType() != typeof(ChildBand))
            {
                ActiveRow = (Row)e.Row;
                xamGrid1_CellClicked(sender, new CellClickedEventArgs());
            }
            else
            {
                IsAlreadyExpanded = false;
            }
        }

        void xamGrid1_CellClicked(object sender, CellClickedEventArgs e)
        {            
            if (ActiveRow != null && (ActiveRow.Data as ChildNode).ChildrenCount != 0)
            {
                if (ActiveRow == null && e.Cell != null && e.Cell.Row.GetType() != typeof(ChildBand))
                    ActiveRow = (Row)e.Cell.Row;

                ChildNode objnode = new ChildNode();
                lstCurrentData = (ObservableCollection<ChildNode>)((XamGrid)sender).ItemsSource;

                if (ActiveRow.Data.GetType() == typeof(AnotherRowDetail))
                {
                    strSelectedID = ((AnotherRowDetail)ActiveRow.Data).ID;
                }
                else
                {
                    strSelectedID = ((ChildNode)ActiveRow.Data).ID;
                }
                lstChildren = new ObservableCollection<ChildNode>();
                lstChildren = objnode.GetTheDataByParentID(strSelectedID, lstParentChildData);

                if (lstChildren.Count > 0)
                {
                    SearchRecursive(lstCurrentData, strSelectedID, lstChildren);
                }

                ActiveRow.IsExpanded = true;
                ActiveRow = null;
                IsAlreadyExpanded = true;
            }
            if(e.Cell != null && (e.Cell.Row.Data as ChildNode).ChildrenCount != 0)
            {
                if (ActiveRow == null && e.Cell != null && e.Cell.Row.GetType() != typeof(ChildBand))
                    ActiveRow = (Row)e.Cell.Row;

                ChildNode objnode = new ChildNode();
                lstCurrentData = (ObservableCollection<ChildNode>)((XamGrid)sender).ItemsSource;

                if (ActiveRow.Data.GetType() == typeof(AnotherRowDetail))
                {
                    strSelectedID = ((AnotherRowDetail)ActiveRow.Data).ID;
                }
                else
                {
                    strSelectedID = ((ChildNode)ActiveRow.Data).ID;
                }
                lstChildren = new ObservableCollection<ChildNode>();
                lstChildren = objnode.GetTheDataByParentID(strSelectedID, lstParentChildData);

                if (lstChildren.Count > 0)
                {
                    SearchRecursive(lstCurrentData, strSelectedID, lstChildren);
                }

                ActiveRow.IsExpanded = true;
                ActiveRow = null;
                IsAlreadyExpanded = true;
            }
        }

        private void xamGrid1_InitializeRow(object sender, Infragistics.Controls.Grids.InitializeRowEventArgs e)
        {
            if (((XamGrid)sender).Columns.ColumnLayouts.Count == 0 && ((ChildNode)e.Row.Data).Children.Count > 0)
            {
                isAdded = false;
            }
            if (!isAdded)
            {
                ((XamGrid)sender).Columns.Add(new TemplateColumnLayout() { Template = this.Resources["MyDataTemplate"] as DataTemplate, Key = "Children" });
                isAdded = true;
            }
        }

        private void XamGrid_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as XamGrid).ItemsSource = ((sender as XamGrid).DataContext as ChildNode).Children;
        }


        private void DownloadDataSource()
        {
            ChildNode objCustomer = new ChildNode();
            /* We are assuming that the data in the csv file is in order with parentdata first. */
            lstParentChildData = objCustomer.GetData("XamGridExpand;component/Data/ParentChild.csv");
            ObservableCollection<ChildNode> rootData = new ObservableCollection<ChildNode>();
            rootData = objCustomer.GetTheDataByParentID("", lstParentChildData);
            xamGrid1.ItemsSource = rootData;
        }

        private void SearchRecursive(ObservableCollection<ChildNode> lstData, string strSelectedID, ObservableCollection<ChildNode> lstChildren)
        {
            ChildNode objNode = new ChildNode();
            AnotherRowDetail objAnotherNode = new AnotherRowDetail();
            for (int i = 0; i < lstData.Count; i++)
            {
                if (lstData[i].ID == strSelectedID && lstData[i].Children.Count == 1)/*If children cnt >0, already added 1 dummy item*/
                {
                    lstData[i].Children.Clear();
                    ////if (strSelectedID == "2010")
                    ////{
                    ////    foreach (ChildNode item in lstChildren)
                    ////    {
                    ////        objAnotherNode = new AnotherRowDetail();
                    ////        if (item.ChildrenCount > 0)
                    ////        {
                    ////            objAnotherNode.Details.Add(new AnotherRowDetail());
                    ////        }
                    ////        objAnotherNode.ID = item.ID;
                    ////        objAnotherNode.Name = item.Name;
                    ////        objAnotherNode.AnotherParentID = item.ParentID;
                    ////        objAnotherNode.DateOfCreation = DateTime.Today;
                    ////        objAnotherNode.IsChainName = true;
                    ////        lstData[i].AnotherDetails.Add(objAnotherNode);
                    ////    }
                    ////}
                    ////else
                    foreach (ChildNode item in lstChildren)
                    {
                        objNode = new ChildNode();
                        /* Added dummy item to get the expander indicator shown */
                        if (item.ChildrenCount > 0)
                        {
                            objNode.Children.Add(new ChildNode());
                        }
                        objNode.ID = item.ID;
                        objNode.Name = item.Name;
                        objNode.ParentID = item.ParentID;
                        objNode.ChildrenCount = item.ChildrenCount;
                        lstData[i].Children.Add(objNode);
                    }
                }
                else if (lstData[i].Children.Count > 0)
                {
                    SearchRecursive(lstData[i].Children, strSelectedID, lstChildren);
                }
            }
        }
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if ((value as ChildNode).ChildrenCount != 0)
            {
                return Visibility.Visible;
            }
            return Visibility.Collapsed;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
